diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 0f412e6ec..f1c2b4de5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -1419,10 +1430,92 @@ public final class Blocks {
         .withSound(BlockSounds.PERMAFROST).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
-    public static final @NotNull Block<BlockLogicFlowstone> FLOWSTONE = register("flowstone", "minecraft:block/flowstone", 1060, BlockLogicFlowstone::new)
-        .withSound(BlockSounds.STONE).withHardness(1.5F).withDisabledNeighborNotifyOnMetadataChange()
+    public static final @NotNull Block<?> BOULDER_MAGMATIC = register("boulder.magmatic", "minecraft:block/boulder_magmatic", 1060, BlockLogicBoulderMagmatic::new)
+        .withHardness(1.0F).withLitInteriorSurface(true).setTicking(true)
+        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE);
+    public static final @NotNull Block<?> BOULDER_SULFURIC = register("boulder.sulfuric", "minecraft:block/boulder_sulfuric", 1061, BlockLogicBoulderSulfuric::new)
+        .withHardness(1.0F).withLitInteriorSurface(true).setTicking(true)
+        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.SULFURIC_FIRE_OVERLAY_SOURCE);
+
+    public static final @NotNull Block<BlockLogicFluid> FLUID_ACID_FLOWING = register("fluid.acid.flowing", "minecraft:block/fluid_acid_flowing", 1062, (BlockLogicSupplier<BlockLogicFluid>) b -> new BlockLogicFluidFlowing(b, Materials.ACID, new FluidAcid(), Blocks.FLUID_ACID_STILL))
+        .withHardness(100.0F).withLitInteriorSurface(true).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange()
+        .withTags(BlockTags.PLACE_OVERWRITES, BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.IS_ACID);
+    public static final @NotNull Block<BlockLogicFluid> FLUID_ACID_STILL = register("fluid.acid.still", "minecraft:block/fluid_acid_still", 1063, (BlockLogicSupplier<BlockLogicFluid>) b -> new BlockLogicFluidStill(b, Materials.ACID, new FluidAcid(), Blocks.FLUID_ACID_FLOWING))
+        .withHardness(100.0F).withLitInteriorSurface(true).withDisabledStats().withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> FLUID_ACID_FLOWING)
+        .withTags(BlockTags.PLACE_OVERWRITES, BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.IS_ACID);
+
+    public static final Block<?> EMBER = register("ember", "minecraft:block/ember", 1065, block -> new BlockLogicEmber(block, Materials.STONE))
+        .withHardness(1.0f).withOverrideColor(MaterialColor.paintedBlack).withLightEmission(5)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NETHER_SURFACE_BLOCK, BlockTags.NETHER_MOBS_SPAWN, BlockTags.CAVES_CUT_THROUGH);
+
+    public static final Block<?> SLATE_CARVED = register("slate.carved", "minecraft:block/slate_carved", 1070, block -> new BlockLogic(block, Materials.SLATE))
+        .withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10.0F).withDisabledStats()
+        .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.NETHER_MOBS_SPAWN);
+    public static final Block<?> SLAB_SLATE_POLISHED = register("slab.slate.carved", "minecraft:block/slab_slate_carved", 1071, block -> new BlockLogicSlab(block, SLATE_CARVED))
+        .withSound(BlockSounds.STONE)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
+    public static final Block<?> LOG_SCORCHED = register("log.scorched", "minecraft:block/log_scorched", 1072, BlockLogicLog::new)
+        .withSound(BlockSounds.WOOD).withHardness(1.5F)
+        .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
+
+    public static final Block<BlockLogicStatue> STATUE_SLATE_LOWER = register("statue.slate.lower", "minecraft:block/statue_slate_lower", 1075, (BlockLogicSupplier<BlockLogicStatue>) block -> new BlockLogicStatue(block, Materials.SLATE, true, () -> Items.STATUE_SLATE))
+        .withSound(BlockSounds.STONE).withHardness(1.5F).setStatParent(() -> Items.STATUE_SLATE)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_SLATE_UPPER = register("statue.slate.upper", "minecraft:block/statue_slate_upper", 1076, (BlockLogicSupplier<BlockLogicStatue>) block -> new BlockLogicStatue(block, Materials.SLATE, false, () -> Items.STATUE_SLATE))
+        .withSound(BlockSounds.STONE).withHardness(1.5F).setStatParent(() -> Items.STATUE_SLATE)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_PERMAFROST_LOWER = register("statue.permafrost.lower", "minecraft:block/statue_permafrost_lower", 1077, (BlockLogicSupplier<BlockLogicStatue>) block -> new BlockLogicStatue(block, Materials.PERMAFROST, true, () -> Items.STATUE_PERMAFROST))
+        .withSound(BlockSounds.PERMAFROST).withHardness(1.5F).setStatParent(() -> Items.STATUE_PERMAFROST)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_PERMAFROST_UPPER = register("statue.permafrost.upper", "minecraft:block/statue_permafrost_upper", 1078, (BlockLogicSupplier<BlockLogicStatue>) block -> new BlockLogicStatue(block, Materials.PERMAFROST, false, () -> Items.STATUE_PERMAFROST))
+        .withSound(BlockSounds.PERMAFROST).withHardness(1.5F).setStatParent(() -> Items.STATUE_PERMAFROST)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_NETHERRACK_LOWER = register("statue.netherrack.lower", "minecraft:block/statue_netherrack_lower", 1079, (BlockLogicSupplier<BlockLogicStatue>) block -> new BlockLogicStatue(block, Materials.NETHERRACK, true, () -> Items.STATUE_NETHERRACK))
+        .withSound(BlockSounds.STONE).withHardness(1.5F).setStatParent(() -> Items.STATUE_NETHERRACK)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_NETHERRACK_UPPER = register("statue.netherrack.upper", "minecraft:block/statue_netherrack_upper", 1080, (BlockLogicSupplier<BlockLogicStatue>) block -> new BlockLogicStatue(block, Materials.NETHERRACK, false, () -> Items.STATUE_NETHERRACK))
+        .withSound(BlockSounds.STONE).withHardness(1.5F).setStatParent(() -> Items.STATUE_NETHERRACK)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_GLOOMSTONE_LOWER = register("statue.gloomstone.lower", "minecraft:block/statue_gloomstone_lower", 1081, (BlockLogicSupplier<BlockLogicStatue>) block -> new BlockLogicStatue(block, Materials.GLOOMSTONE, true, () -> Items.STATUE_GLOOMSTONE))
+        .withSound(BlockSounds.STONE).withHardness(1.5F).setStatParent(() -> Items.STATUE_GLOOMSTONE)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_GLOOMSTONE_UPPER = register("statue.gloomstone.upper", "minecraft:block/statue_gloomstone_upper", 1082, (BlockLogicSupplier<BlockLogicStatue>) block -> new BlockLogicStatue(block, Materials.GLOOMSTONE, false, () -> Items.STATUE_GLOOMSTONE))
+        .withSound(BlockSounds.STONE).withHardness(1.5F).setStatParent(() -> Items.STATUE_GLOOMSTONE)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+
+    public static final Block<?> BRIMSAND = register("brimsand", "minecraft:block/brimsand", 1085, (b) -> new BlockLogic(b, Materials.SAND))
+        .withSound(BlockSounds.SAND).withHardness(0.7F)
+        .withTags(BlockTags.MINEABLE_BY_SHOVEL, BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN, BlockTags.NETHER_SURFACE_BLOCK, BlockTags.INFINITE_BURN_SULFURIC);
+    public static final Block<?> BRIMSTONE = register("brimstone", "minecraft:block/brimstone", 1086, block -> new BlockLogicBrimstone(block, Materials.STONE))
+        .withSound(BlockSounds.STONE).withHardness(1.8F).withOverrideColor(MaterialColor.paintedBlack)
+        .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.NETHER_MOBS_SPAWN, BlockTags.NETHER_SURFACE_BLOCK, BlockTags.INFINITE_BURN_SULFURIC);
+    public static final Block<?> SLAB_BRIMSTONE = register("slab.brimstone", "minecraft:block/slab_brimstone", 1087, block -> new BlockLogicSlab(block, BRIMSTONE))
+        .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true).withOverrideColor(MaterialColor.paintedBlack)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN_SULFURIC);
+    public static final Block<?> STAIRS_BRIMSTONE = register("stairs.brimstone", "minecraft:block/stairs_brimstone", 1088, block -> new BlockLogicStairs(block, BRIMSTONE))
+        .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true).withOverrideColor(MaterialColor.paintedBlack)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN_SULFURIC);
+    public static final Block<?> BRICK_BRIMSTONE = register("brick.brimstone", "minecraft:block/brick_brimstone", 1089, block -> new BlockLogicBrimstone(block, Materials.STONE))
+        .withSound(BlockSounds.STONE).withHardness(1.8F).withOverrideColor(MaterialColor.paintedBlack)
+        .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.NETHER_MOBS_SPAWN, BlockTags.NETHER_SURFACE_BLOCK, BlockTags.INFINITE_BURN_SULFURIC);
+    public static final Block<?> SLAB_BRICK_BRIMSTONE = register("slab.brick.brimstone", "minecraft:block/slab_brick_brimstone", 1090, block -> new BlockLogicSlab(block, BRICK_BRIMSTONE))
+        .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true).withOverrideColor(MaterialColor.paintedBlack)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN_SULFURIC);
+    public static final Block<?> STAIRS_BRICK_BRIMSTONE = register("stairs.brick.brimstone", "minecraft:block/stairs_brick_brimstone", 1091, block -> new BlockLogicStairs(block, BRICK_BRIMSTONE))
+        .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true).withOverrideColor(MaterialColor.paintedBlack)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN_SULFURIC);
+    public static final @NotNull Block<?> BRIMTHAW = register("brimthaw", "minecraft:block/brimthaw", 1092, BlockLogicBrimthaw::new)
+        .withSound(BlockSounds.STONE).withHardness(1.25F).withBlastResistance(7F).withLightEmission(10).withOverrideColor(MaterialColor.paintedYellow)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN_SULFURIC, BlockTags.SULFURIC_FIRE_OVERLAY_SOURCE);
+
+    public static final Block<?> SULFUR = register("sulfur", "minecraft:block/sulfur", 1098, BlockLogicSulfur::new)
+        .withSound(BlockSounds.SAND).withHardness(0.5f).withOverrideColor(MaterialColor.paintedYellow)
+        .withTags(BlockTags.MINEABLE_BY_SHOVEL, BlockTags.NETHER_SURFACE_BLOCK, BlockTags.NETHER_MOBS_SPAWN, BlockTags.CAVES_CUT_THROUGH, BlockTags.INFINITE_BURN_SULFURIC);
+    public static final Block<?> SULFUR_HARDENED = register("sulfur_hardened", "minecraft:block/sulfur_hardened", 1099, BlockLogicSulfurHardened::new)
+        .withSound(BlockSounds.SAND).withHardness(0.5f).withOverrideColor(MaterialColor.paintedYellow)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NETHER_SURFACE_BLOCK, BlockTags.NETHER_MOBS_SPAWN, BlockTags.CAVES_CUT_THROUGH, BlockTags.INFINITE_BURN_SULFURIC);
+
     public static <T extends BlockLogic> Block<T> register(String key, String namespaceId, int id, BlockLogicSupplier<T> logicSupplier) {
         Block<T> container = new Block<>(id, key, namespaceId, logicSupplier);
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/FluidAcid.java b/game/core/src/main/java/net/minecraft/core/block/FluidAcid.java
new file mode 100644
index 000000000..dc9189408
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/FluidAcid.java
@@ -0,0 +1,107 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.world.LevelListener;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Random;
+
+public class FluidAcid implements Fluid {
+	public FluidAcid() {
+	}
+
+	public int tickDelay() {
+		return 40;
+	}
+
+	@Override
+	public void animationTick(@NotNull BlockLogicFluid logicFluid, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+		int data = world.getBlockData(tilePos) & 15;
+		TilePos queryPos = new TilePos();
+
+		boolean isBottom = world.isBlockOpaqueCube(tilePos.down(queryPos));
+		if (rand.nextInt(64) == 0) {
+			world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) tilePos.x() + 0.5F, (float) tilePos.y() + 0.5F, (float) tilePos.z() + 0.5F,
+				"random.fizz", rand.nextFloat() * 0.125F, rand.nextFloat() + 0.5F);
+		}
+
+		if (rand.nextInt(64) == 0) {
+			world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) tilePos.x() + 0.5F, (float) tilePos.y() + 0.5F, (float) tilePos.z() + 0.5F,
+				"tile.acidbubble", rand.nextFloat() * 0.25F + 0.25F, rand.nextFloat() - 1.0F);
+		}
+
+		if ((isBottom || rand.nextInt(16) == 0) && data == 0 && rand.nextInt(2) == 0) {
+			world.spawnParticle("acidBoiling", (double) tilePos.x() + Math.random(), (float) tilePos.y() + 0.05F, (double) tilePos.z() + Math.random(), 0.0F, 0.0F, 0.0F, 0, false);
+		}
+
+		if (rand.nextInt(4) == 0 && world.getBlockType(tilePos.down(new TilePos())).solid() && !world.getBlockType(tilePos.down(new TilePos()).down()).solid()) {
+			float off1 = rand.nextFloat() * 0.9F + 0.05F;
+			float off2 = rand.nextFloat() * 0.9F + 0.05F;
+			float lOff = 0.01F;
+			world.spawnParticle("acidDrip", (float) tilePos.x() + off1, (float) (tilePos.y() - 1) - lOff, (float) tilePos.z() + off2, 0.0F, 0.0F, 0.0F, 0, false);
+		}
+
+	}
+
+	@Override
+	public boolean checkForHarden(@NotNull BlockLogicFluid logicFluid, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Material encountered) {
+		if (encountered == Materials.LAVA || encountered == Materials.WATER) {
+			final int data = world.getBlockData(tilePos) & 15;
+			final boolean netherWorld = world.getWorldType().hasTag(WorldTypeTags.NETHER);
+			if (netherWorld) {
+				if (data == 0) {
+					world.setBlockTypeNotify(tilePos, Blocks.BRIMTHAW);
+				} else {
+					world.setBlockTypeNotify(tilePos, Blocks.BRIMSTONE);
+				}
+			} else {
+				if (data == 0) {
+					world.setBlockTypeNotify(tilePos, Blocks.SULFUR);
+				} else {
+					world.setBlockTypeNotify(tilePos, Blocks.SULFUR_HARDENED);
+				}
+			}
+
+			world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) tilePos.x() + 0.5F, (float) tilePos.y() + 0.5F, (float) tilePos.z() + 0.5F, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
+
+			for (int i = 0; i < 8; ++i) {
+				world.spawnParticle("largesmoke", (double) tilePos.x() + Math.random(), (double) tilePos.y() + 1.01, (double) tilePos.z() + Math.random(), 0.0F, 0.0F, 0.0F, 0, false);
+			}
+			return true;
+		} else {
+			return false;
+		}
+	}
+
+	public boolean shouldTick() {
+		return false;
+	}
+
+	public void updateTickStill(@NotNull BlockLogicFluid logicFluid, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+	}
+
+	public byte getFlowDecayMod(@NotNull BlockLogicFluid logicFluid, @NotNull World world, @NotNull TilePosc tilePos) {
+		return 2;
+	}
+
+	public boolean canBecomeSource(@NotNull BlockLogicFluid logicFluid, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+		return false;
+	}
+
+	public void onFlowIntoBlock(@NotNull BlockLogicFluid logicFluid, @NotNull World world, @NotNull TilePos tilePos, int meta) {
+		world.getBlockType(tilePos).dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
+		world.playBlockEvent(tilePos, LevelListener.EVENT_ACID_SPREAD, 0);
+	}
+
+	public boolean canSpreadTo(@NotNull BlockLogicFluid logicFluid, @NotNull World world, @NotNull TilePos tilePos, @NotNull Material material) {
+		return material != Materials.LAVA && material != Materials.WATER;
+	}
+}
+
diff --git a/game/core/src/main/java/net/minecraft/core/block/FluidLava.java b/game/core/src/main/java/net/minecraft/core/block/FluidLava.java
index d307bf7c6..fc8367a19 100644
--- a/game/core/src/main/java/net/minecraft/core/block/FluidLava.java
+++ b/game/core/src/main/java/net/minecraft/core/block/FluidLava.java
@@ -59,6 +59,10 @@ public class FluidLava
                 }
             }
 
+            BlockLogicFluid.fizz(world, tilePos);
+            return true;
+        } else if (encountered == Blocks.FLUID_ACID_STILL.getMaterial()) {
+            world.setBlockTypeNotify(tilePos, Blocks.SULFUR_HARDENED);
             BlockLogicFluid.fizz(world, tilePos);
             return true;
         }
@@ -125,6 +129,6 @@ public class FluidLava
 
     @Override
     public boolean canSpreadTo(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Material material) {
-        return material != Materials.LAVA;
+        return material != Materials.WATER && material != Blocks.FLUID_ACID_STILL.getMaterial();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/FluidWater.java b/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
index 4460b1a87..ccbd936ef 100644
--- a/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
@@ -61,6 +61,10 @@ public class FluidWater
             }
             BlockLogicFluid.fizz(world, tilePos);
             return true;
+        } else if (encountered == Blocks.FLUID_ACID_STILL.getMaterial()) {
+            world.setBlockTypeNotify(tilePos, Blocks.SULFUR_HARDENED);
+            BlockLogicFluid.fizz(world, tilePos);
+            return true;
         }
         return false;
     }
@@ -92,6 +96,6 @@ public class FluidWater
 
     @Override
     public boolean canSpreadTo(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Material material) {
-        return material != Materials.LAVA;
+        return material != Materials.LAVA && material != Blocks.FLUID_ACID_STILL.getMaterial();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/material/Materials.java b/game/core/src/main/java/net/minecraft/core/block/material/Materials.java
index bdd7e38ad..7b24e0757 100644
--- a/game/core/src/main/java/net/minecraft/core/block/material/Materials.java
+++ b/game/core/src/main/java/net/minecraft/core/block/material/Materials.java
@@ -51,6 +51,6 @@ public final class Materials {
     public static final @NotNull Material PISTON = new Material(MaterialColor.stone);
     public static final @NotNull Material MOSS = new Material(MaterialColor.grass).flammable().notAlwaysDestroyable();
     public static final @NotNull Material WOOD_WET = (new Material(MaterialColor.grass).setConductivity(Material.LIGHTNING_LIGHT_CONDUCTOR));
-
+    public static final @NotNull Material ACID = new MaterialLiquid(MaterialColor.paintedYellow).setConductivity(5).destroyOnPush();
     private Materials() { }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
index 95d6d5b68..cb836acbe 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
@@ -36,6 +36,7 @@ import static net.minecraft.core.block.piston.PistonCommon.*;
 public class BlockLogicPistonHead extends BlockLogic implements ICarrySource {
 
     // "Good lord. This really is our most NSFW update" -- Jonk
+    // "Daaayyymmnn boy! He thick boy! That's a thick ass boy, DAYMN!" -- Melon
     final double headThickness, shaftThickness;
 
     public BlockLogicPistonHead(final Block<?> block, final double headThickness, final double shaftThickness) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java b/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
index 5f4b11937..ea1db34c2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
+++ b/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
@@ -68,6 +68,10 @@ public abstract class BlockTags
      * derived block has the properties of lava.
      */
     public static final Tag<Block<?>> IS_LAVA = Tag.of("is_lava");
+    /**
+     * derived block has the properties of acid.
+     */
+    public static final Tag<Block<?>> IS_ACID = Tag.of("is_acid");
     /**
      * {@link BlockLogicFlower BlockFlower}-derived blocks can be placed on this block.
      */
@@ -150,9 +154,17 @@ public abstract class BlockTags
      */
     public static final Tag<Block<?>> INFINITE_BURN = Tag.of("infinite_burn");
     /**
-     * Block allows fire to burn forever on it {@link BlockLogicFire BlockFire}
+     * Block allows fire to burn forever on it {@link net.minecraft.core.block.BlockLogicFireCold BlockFireCold}
      */
     public static final Tag<Block<?>> INFINITE_BURN_COLD = Tag.of("infinite_burn_cold");
+    /**
+     * Block allows fire to burn forever on it {@link net.minecraft.core.block.BlockLogicFireSulfuric BlockFireSulfuric}
+     */
+    public static final Tag<Block<?>> INFINITE_BURN_SULFURIC = Tag.of("infinite_burn_sulfuric");
+    /**
+     * Set entity on sulfuric fire instead of Normal Fire
+     */
+    public static final Tag<Block<?>> SULFURIC_FIRE_OVERLAY_SOURCE = Tag.of("sulfuric_fire_overlay_source");
     /**
      * Block is broken on contact with an {@link EntityBoat EntityBoat}
      */
diff --git a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRules.java b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRules.java
index d6199334e..509fb9c7f 100644
--- a/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRules.java
+++ b/game/core/src/main/java/net/minecraft/core/data/gamerule/GameRules.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.data.gamerule;
 
 import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.entity.Entity;
 
 public abstract class GameRules
 {
@@ -16,6 +17,7 @@ public abstract class GameRules
     public static GameRuleBoolean DO_WEATHER_CYCLE = register(new GameRuleBoolean("doWeatherCycle", "gamerule.do_weather_cycle", true));
     public static GameRuleBoolean DO_FIRE_SPREAD = register(new GameRuleBoolean("doFireSpread", "gamerule.do_fire_spread", true));
     public static GameRuleBoolean INSTANT_HEALING = register(new GameRuleBoolean("instantHealing", "gamerule.instant_healing", false));
+    public static GameRuleInteger ACID_MELT_RATE = register(new GameRuleInteger("acidMeltRate", "gamerule.acid_melt_rate", Entity.FIRE_DAMAGE_INTERVAL_TICKS));
     public static GameRuleInteger RANDOM_TICK_SPEED = register(new GameRuleInteger("randomTickSpeed", "gamerule.random_tick_speed", 4));
     public static GameRuleInteger ITEM_DESPAWN_DELAY = register(new GameRuleInteger("itemDespawnDelay", "gamerule.item_despawn_delay", 12000));
     public static GameRuleInteger DROPPED_ITEM_DESPAWN_DELAY = register(new GameRuleInteger("droppedItemDespawnDelay", "gamerule.dropped_item_despawn_delay", 12000));
